<?
$mainGUI = &GUIFactory::setMainGUI( "main" );

$form = new HtmlForm3("edit_inherited");
if ($form->isNew()) {
 switch($OBJ_TYPE) {
 case T_PAGE:
 $icon = $ICO_PAGE;
 $label = "page";
 $info = get_pageinfo($OBJ_ID);
 break;
 case T_TEMPLATE:
 $icon = $ICO_TPL;
 $label = "template";
 $info = get_templateinfo($OBJ_ID);
 break;
 case T_FOLDER:
 $icon = $ICO_FOLDER;
 $label = "folder";
 $info = get_folderinfo($OBJ_ID);
 break;
 case T_IMAGE:
 $icon = $ICO_IMAGE;
 $label = "image";
 $info = get_fileinfo($OBJ_ID);
 break;
 case CT_FILE:
 $icon = $ICO_FILE;
 $label = "file";
 $info = get_fileinfo($OBJ_ID);
 break;
 }
 if ($info["channel_id"] != 0) {
 
 $nodeinfo = get_nodeinfo($info["channel_id"]);
 } else {
 
 $masterNodes = getMasterNodes($NODE_ID);
 if (is_array($masterNodes) && count($masterNodes) > 0) {
 $nodeinfo = get_nodeinfo($masterNodes[count($masterNodes) - 1]);
 }
 }
 if (!$nodeinfo) {
 halt(7, "Could not get master nodes for NODE_ID $NODE_ID.");
 }

 $form->setHeader(i18n("edit_inherited_header"));

 $main = new ListComponent();

 
 $main->setComponent('info', new LabelComponent(null, i18n('edit_inherited_info'), true));
 $main->setComponent('object', new LabelComponent(i18n($label), img($icon)."&nbsp;".htmlentities_utf8($info["name"]), true));
 $main->setComponent('node', new LabelComponent(i18n('inherited_from'), img($ICO_DOMAIN)."&nbsp;".htmlentities_utf8($nodeinfo["name"]), true));

 
 $main->setComponent('inherited_node', new HiddenComponent($nodeinfo["id"]));
 $main->setComponent('obj_type', new HiddenComponent($OBJ_TYPE));
 $main->setComponent('do_cancel', new HiddenComponent($DO_CANCEL));
 $main->setComponent('do_edit', new HiddenComponent($DO_EDIT));
 $main->setComponent('obj_id', new HiddenComponent($OBJ_ID));
 $main->setComponent('obj_id_param', new HiddenComponent($OBJ_ID_PARAM));
 $main->setComponent('do_params', new HiddenComponent($DO_PARAMS));

 $form->addComponent('main', $main);
 $form->addButton('inherited', new Button(i18n("edit_inherited_button")), new SimpleFormAction("editInherited"), true);
 $form->addButton('localize', new Button(i18n("edit_localized_button")), new SimpleFormAction("localizeAndEdit"), false);
 $form->addButton('cancel', new Button(i18n("cancel")), new RedoFormAction($DO_CANCEL), false);

 
 
 $response = getFromREST("/perm/edit/$OBJ_TYPE/$OBJ_ID");

 if (!$response["granted"] || isFeatureActivatedForNode('always_localize', $NODE_ID)) {
 localizeAndEdit($form);
 }
}
?>
