<?php

function cmd_tasktemplate_del( $id )
{
 global $W_DEL, $T_TASK_TEMPLATE;

 
 $sql = "SELECT id FROM task WHERE tasktemplate_id=".sqlf_tl_num($id);
 $rs = query($sql);
 foreach ($rs["arr"] as $result) {
 $err = cmd_task_del($result["id"]);
 if ( $err )
 return $err;
 } 
 
 $sql = "DELETE FROM tasktemplate WHERE id=".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM tasktemplateparam WHERE tasktemplate_id=".sqlf_tl_num($id);
 query($sql);

 perm_remove_perms($T_TASK_TEMPLATE, $id);

 logcmd($W_DEL, $T_TASK_TEMPLATE, $id, 0, "cmd_tasktemplate_del...");
} 

function cmd_task_del( $id )
{
 global $W_DEL, $T_TASK;

 
 $sql = "SELECT * FROM job WHERE task_id=".sqlf_tl_num($id);
 $rs = query($sql);
 foreach ($rs["arr"] as $result) {
 $err = cmd_job_del($result["id"]);
 if ( $err )
 return $err;
 } 
 $sql = "DELETE FROM task WHERE id=".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM taskparam WHERE task_id=".sqlf_tl_num($id);
 query($sql);

 perm_remove_perms($T_TASK, $id);

 logcmd($W_DEL, $T_TASK, $id, 0, "cmd_task_del...");
} 

function cmd_job_del( $id )
{
 global $W_DEL, $T_JOB;

 if ( count( $jobs=cmd_get_dependent_jobs($id) ) > 0 )
 {
 $jobTable = new SqlTable( "job" );
 $jobs = $jobTable->findBy( "id", $id );
 $tName = $jobs[0]->getValue("name");
 return i18n("del_job_dependencies", 0, $tName);
 }
 
 $sql = "DELETE FROM job WHERE id=".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM jobrun WHERE job_id=".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM jobdependency WHERE jobid=".sqlf_tl_num($id);
 query($sql);

 perm_remove_perms($T_JOB, $id);

 logcmd($W_DEL, $T_JOB, $id, 0, "cmd_job_del...");
} 








function cmd_update_job_dependencies( $jobid, $deps )
{
 $sql = "DELETE FROM jobdependency WHERE jobid = ".sqlf_tl_num($jobid);
 query( $sql );
 if ( !is_array ($deps) )
 return;
 foreach ( $deps as $dep )
 {
 $sql = "INSERT INTO jobdependency ( jobid, depid ) VALUES ( ".sqlf_tl_num($jobid).", ".sqlf_tl_num($dep)." )";
 query( $sql );
 }
}

function cmd_get_dependent_jobs( $jobid )
{
 node_class( "sqltable" );
 $table = new SqlTable( "jobdependency" );
 return $table->findBy( "depid", $jobid );
}

?>