<?









function delete_lost_data($deltable, $sql, $delkey = "id", $delkey2 = "id") {
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "DELETE FROM ".sqlf_table($deltable)." WHERE ".sqlf_field($delkey)." = ".sqlf_value($val[$delkey])." AND ".sqlf_field($delkey2)." = ".sqlf_value($val[$delkey2]);
 query($sql);
 }
 }
}

function consistency_get_definition() {

global $FILEPATH, $T_PAGE, $T_FOLDER;



$con["value1"]["sql"] = "SELECT count(id) AS c FROM value WHERE 
contenttag_id = 0 AND templatetag_id = 0 AND objtag_id = 0 AND static = 0 GROUP BY value.part_id HAVING count(id) > 1";
$con["value1"]["rs"] = query($con["value1"]["sql"]);


$con["value3"]["sql"] = "SELECT count(id) AS c FROM value WHERE static = 1 GROUP BY part_id HAVING c > 1";
$con["value3"]["rs"] = query($con["value3"]["sql"]);






















echo " ";

$con["value_part3"]["sql"] = "SELECT count(id) AS c FROM value WHERE contenttag_id = 0 and templatetag_id = 0 AND objtag_id = 0
GROUP BY part_id HAVING count(id) > 1";
$con["value_part3"]["rs"] = query($con["value_part3"]["sql"]);
echo " ";

$con["value.static"]["sql"] = "SELECT value.id FROM value, part WHERE part.id = value.part_id AND ((value.static = 0 AND part.editable = 0) OR (value.static = 1 AND part.editable > 0))";
$con["value.static"]["rs"] = query($con["value.static"]["sql"]);
$con["value.static"]["del"] = "delete_lost_data(\"value\",\$con[\"value.static\"][\"sql\"]);";
echo " ";

$con["contenttag2"]["sql"] = "SELECT contenttag.id FROM contenttag LEFT JOIN content ON contenttag.content_id = content.id WHERE content.id IS NULL";
$con["contenttag2"]["rs"] = query($con["contenttag2"]["sql"]);
$con["contenttag2"]["del"] = "delete_lost_data(\"contenttag\",\$con[\"contenttag2\"][\"sql\"]);";
echo " ";

$con["templatetag2"]["sql"] = "SELECT templatetag.id FROM templatetag LEFT JOIN template ON templatetag.template_id = template.id WHERE template.id IS NULL";
$con["templatetag2"]["rs"] = query($con["templatetag2"]["sql"]);
$con["templatetag2"]["del"] = "delete_lost_data(\"templatetag\",\$con[\"templatetag2\"][\"sql\"]);";
echo " ";

$con["value_part"]["sql"] = "SELECT value.id FROM value LEFT JOIN part ON value.part_id = part.id WHERE part.id IS null";
$con["value_part"]["rs"] = query($con["value_part"]["sql"]);
$con["value_part"]["del"] = "delete_lost_data(\"value\",\$con[\"value_part\"][\"sql\"]);";
echo " ";

$con["value2"]["sql"] = "SELECT id FROM value WHERE (contenttag_id > 0 AND templatetag_id > 0) OR (templatetag_id > 0 AND objtag_id > 0) OR (contenttag_id > 0 AND objtag_id > 0) OR (contenttag_id > 0 AND templatetag_id > 0 AND objtag_id > 0)";
$con["value2"]["rs"] = query($con["value2"]["sql"]);
$con["value2"]["del"] = "delete_lost_data(\"value\",\$con[\"value2\"][\"sql\"]);";
echo " ";

$con["templatetag"]["sql"] = "SELECT COUNT(id) AS c FROM templatetag GROUP BY template_id, name HAVING count(id) > 1";
$con["templatetag"]["rs"] = query($con["templatetag"]["sql"]);
echo " ";

$con["contenttag"]["sql"] = "SELECT COUNT(content_id) AS c FROM contenttag GROUP BY content_id, name HAVING count(content_id) > 1";
$con["contenttag"]["rs"] = query($con["contenttag"]["sql"]);
echo " ";

$con["objtag"]["sql"] = "SELECT COUNT(id) AS c FROM objtag GROUP BY obj_id, name HAVING count(id) > 1";
$con["objtag"]["rs"] = query($con["objtag"]["sql"]);
echo " ";

echo " ";

$con["page_folder"]["sql"] = "SELECT page.id FROM page LEFT JOIN folder ON page.folder_id = folder.id WHERE folder.id IS null";
$con["page_folder"]["rs"] = query($con["page_folder"]["sql"]);
$con["page_folder"]["del"] = "delete_lost_data(\"page\",\$con[\"page_folder\"][\"sql\"]);";
echo " ";

$con["contentfile_folder"]["sql"] = "SELECT contentfile.id FROM contentfile LEFT JOIN folder ON folder.id = contentfile.folder_id WHERE folder.id IS NULL";
$con["contentfile_folder"]["rs"] = query($con["contentfile_folder"]["sql"]);
$con["contentfile_folder"]["del"] = "delete_lost_data(\"contentfile\",\$con[\"contentfile_folder\"][\"sql\"]);";
echo " ";

$sql = "SELECT id FROM contentfile";
$rs = query($sql);
$r = array("num"=>0,"iid"=>0,"arr"=>array());
if ($rs["arr"]) {
 $info = "";
 while (list($key,$val) = each($rs["arr"])) {
 $id = $val["id"];
 if (!file_exists($FILEPATH."/content/dbfiles/".$id.".bin")) {
 $r["num"]++;
 $r["arr"][] = array("id"=>$id);
 $info .= $id.", ";
 }
 }
} 
$con["contentfile_dbfile"]["sql"] = $sql;
$con["contentfile_dbfile"]["rs"] = $r;
$con["contentfile_dbfile"]["info"] = $info;
unset($info);
echo " ";

$con["folder"]["sql"] = "SELECT folder.id, folder.mother FROM folder LEFT JOIN folder $SQLAS f ON f.id = folder.mother WHERE f.id IS NULL AND folder.mother > 0";
$con["folder"]["rs"] = query($con["folder"]["sql"]);
$con["folder"]["del"] = "delete_lost_data(\"folder\",\$con[\"folder\"][\"sql\"]);";
echo " ";

$con["folder2"]["sql"] = "SELECT folder.mother FROM folder LEFT JOIN folder $SQLAS folder2 ON folder.mother = folder2.id
WHERE folder.mother > 0 AND folder.node_id != folder2.node_id";
$con["folder2"]["rs"] = query($con["folder2"]["sql"]);
echo " ";

$con["folder_pub_dir1"]["sql"] = "SELECT folder.id FROM folder WHERE pub_dir NOT LIKE '/%'";
$con["folder_pub_dir1"]["rs"] = query($con["folder_pub_dir1"]["sql"]);
echo " ";

$con["folder_pub_dir2"]["sql"] = "SELECT folder.id FROM folder WHERE pub_dir NOT LIKE '%/'";
$con["folder_pub_dir2"]["rs"] = query($con["folder_pub_dir2"]["sql"]);
echo " ";

$con["construct_node1"]["sql"] = "SELECT construct_id, node_id FROM construct_node LEFT JOIN construct ON construct_node.construct_id = construct.id WHERE construct.id IS NULL";
$con["construct_node1"]["rs"] = query($con["construct_node1"]["sql"]);
$con["construct_node1"]["del"] = "delete_lost_data(\"construct_node\",\$con[\"construct_node1\"][\"sql\"],\"construct_id\",\"node_id\");";
echo " ";

$con["construct_node2"]["sql"] = "SELECT construct_id, node_id FROM construct_node LEFT JOIN node ON construct_node.node_id = node.id WHERE node.id IS NULL";
$con["construct_node2"]["rs"] = query($con["construct_node2"]["sql"]);
$con["construct_node2"]["del"] = "delete_lost_data(\"construct_node\",\$con[\"construct_node2\"][\"sql\"],\"construct_id\",\"node_id\");";
echo " ";

$con["page"]["sql"] = "SELECT id FROM page WHERE content_id = 0";
$con["page"]["rs"] = query($con["page"]["sql"]);
echo " ";

$con["page_content1"]["sql"] = "SELECT page.id FROM page LEFT JOIN content ON page.content_id = content.id WHERE content.id IS NULL";
$con["page_content1"]["rs"] = query($con["page_content1"]["sql"]);
$con["page_content1"]["del"] = "delete_lost_data(\"page\",\$con[\"page_content1\"][\"sql\"]);";
echo " ";

$con["page_content2"]["sql"] = "SELECT content.id FROM content LEFT JOIN page ON content.id = page.content_id WHERE page.id IS NULL";
$con["page_content2"]["rs"] = query($con["page_content2"]["sql"]);
$con["page_content2"]["del"] = "delete_lost_data(\"content\",\$con[\"page_content2\"][\"sql\"]);";
echo " ";

$con["templatetag_construct"]["sql"] = "SELECT templatetag.id FROM templatetag LEFT JOIN construct ON templatetag.construct_id = construct.id WHERE construct.id IS NULL";
$con["templatetag_construct"]["rs"] = query($con["templatetag_construct"]["sql"]);
$con["templatetag_construct"]["del"] = "delete_lost_data(\"templatetag\",\$con[\"templatetag_construct\"][\"sql\"]);";
echo " ";

$con["contenttag_construct"]["sql"] = "SELECT contenttag.id FROM contenttag LEFT JOIN construct ON contenttag.construct_id = construct.id WHERE construct.id IS NULL";
$con["contenttag_construct"]["rs"] = query($con["contenttag_construct"]["sql"]);
$con["contenttag_construct"]["del"] = "delete_lost_data(\"contenttag\",\$con[\"contenttag_construct\"][\"sql\"]);";
echo " ";

$con["objtag_construct"]["sql"] = "SELECT objtag.id FROM objtag LEFT JOIN construct ON objtag.construct_id = construct.id WHERE construct.id IS NULL";
$con["objtag_construct"]["rs"] = query($con["objtag_construct"]["sql"]);
$con["objtag_construct"]["del"] = "delete_lost_data(\"objtag\",\$con[\"objtag_construct\"][\"sql\"]);";
echo " ";

$con["user_group_user"]["sql"] = "SELECT systemuser.id FROM systemuser LEFT JOIN user_group ON user_group.user_id = systemuser.id WHERE user_group.user_id IS NULL AND systemuser.active = 1";
$con["user_group_user"]["rs"] = query($con["user_group_user"]["sql"]);
echo " ";

$con["user_group_group"]["sql"] = "SELECT usergroup_id FROM user_group LEFT JOIN usergroup ON user_group.usergroup_id = usergroup.id WHERE usergroup.id IS NULL";
$con["user_group_group"]["rs"] = query($con["user_group_group"]["sql"]);
echo " ";

$con["usergroup"]["sql"] = "SELECT usergroup.id, usergroup.mother FROM usergroup LEFT JOIN usergroup $SQLAS u ON u.id = usergroup.mother WHERE u.id IS NULL AND usergroup.mother > 0";
$con["usergroup"]["rs"] = query($con["usergroup"]["sql"]);
echo " ";

$con["tree"]["sql"] = "SELECT tree.id, tree.mother FROM tree LEFT JOIN tree $SQLAS t ON t.id = tree.mother WHERE t.id IS NULL AND tree.mother > 0";
$con["tree"]["rs"] = query($con["tree"]["sql"]);
echo " ";

$con["node_folder1"]["sql"] = "SELECT node.id FROM node LEFT JOIN folder ON folder.id = node.folder_id WHERE folder.id IS NULL";
$con["node_folder1"]["rs"] = query($con["node_folder1"]["sql"]);
echo " ";

$con["node_folder2"]["sql"] = "SELECT node.id, folder.id, folder.mother FROM node, folder WHERE node.folder_id = folder.id AND folder.mother != 0";
$con["node_folder2"]["rs"] = query($con["node_folder2"]["sql"]);
echo " ";

$con["node_folder3"]["sql"] = "SELECT folder.id FROM folder LEFT JOIN node ON folder.node_id = node.id WHERE node.id IS NULL";
$con["node_folder3"]["rs"] = query($con["node_folder3"]["sql"]);
$con["node_folder3"]["del"] = "delete_lost_data(\"folder\",\$con[\"node_folder3\"][\"sql\"]);";
echo " ";

$con["objpropspage"]["sql"] = "select objtag.id from objtag left join page on ( page.id=objtag.obj_id and objtag.obj_type=".sqlf_tl_num($T_PAGE)." ) WHERE page.id is null AND objtag.obj_id != 0 AND objtag.obj_type=".sqlf_tl_num($T_PAGE);
$con["objpropspage"]["rs"] = query($con["objpropspage"]["sql"]);
$con["objpropspage"]["del"] = "delete_lost_data(\"objtag\",\$con[\"objpropspage\"][\"sql\"]);";
echo ".";

$con["objpropsfolder"]["sql"] = "select objtag.id from objtag left join folder on ( folder.id=objtag.obj_id and objtag.obj_type=".sqlf_tl_num($T_FOLDER)." ) WHERE folder.id is null AND objtag.obj_id != 0 AND objtag.obj_type=".sqlf_tl_num($T_FOLDER);
$con["objpropsfolder"]["rs"] = query($con["objpropsfolder"]["sql"]);
$con["objpropsfolder"]["del"] = "delete_lost_data(\"objtag\",\$con[\"objpropsfolder\"][\"sql\"]);";
echo ".";


$con["publish"]["sql"] = "SELECT publish.id FROM publish LEFT JOIN page ON publish.page_id = page.id WHERE page.id IS NULL";
$con["publish"]["rs"] = query($con["publish"]["sql"]);
$con["publish"]["del"] = "delete_lost_data(\"publish\",\$con[\"publish\"][\"sql\"]);";
echo " ";

$con["contentgroup"]["sql"] = "SELECT count(id) AS c FROM page WHERE contentset_id > 0 AND contentgroup_id > 0 GROUP BY contentset_id, contentgroup_id HAVING c > 1";
$con["contentgroup"]["rs"] = query($con["contentgroup"]["sql"]);
echo " ";

$con["contentset"]["sql"] = "SELECT count(id) AS c FROM page WHERE contentset_id = 0 OR contentset_id IS NULL";
$con["contentset"]["rs"] = query($con["contentgroup"]["sql"]);
$con["contentset"]["del"] = "echo \"Use dev.scripts creates contentsets for pages having contentset_id = 0 to clean up...\" ;";
echo " ";

$con["contentset2"]["sql"] = "SELECT id FROM page WHERE contentgroup_id > 0 AND contentset_id = 0";
$con["contentset2"]["rs"] = query($con["contentset2"]["sql"]);
$con["contentset2"]["del"] = "sanity_reset_contentgroup();";

return $con;
}

function sanity_reset_contentgroup() {
 $sql = "UPDATE page SET contentgroup_id = 0 WHERE contentset_id = 0";
 query($sql);
}

function consistency_check($con) {

global $STAG;

$err = 0;
$errc = 0;
while (list($key,$val) = each($con)) {
 if ($del == $key && $con[$key]["del"]) {
 eval($con[$key]["del"]);
 }
 $outp .= "<tr valign=top>\n";
 if ($con[$key]["del"])
$outp .= "<td>$key <a href=\"javascript:askdel('$key: ".htmlentities_utf8($con[$key]["del"])."','$STAG&do=823&del=$key');\">x</a></td>\n";
 else $outp .= "<td>$key</td>\n";
 $outp .= "<td>".$val["rs"]["num"]."</td>
  <td>".$val["sql"]."</td>
  <td>".$val["info"]."&nbsp;</td>
</tr>\n";
 if ($val["rs"]["num"] > 0) {
 $err++;
 $errc += $val["rs"]["num"];
 }















}

$ret = Array();
$ret["outp"] = $outp;
$ret["err"] = $err;
$ret["errc"] = $errc;

return $ret;

}


function consistency_save_stat($err,$errc) {
 $err = sqlf_tl_num($err);
 $errc = sqlf_tl_num($errc);
 $sql = "SELECT name FROM nodesetup WHERE name = 'estat'";
 $rs = query($sql);
 if ($rs["num"] == 0) $sql = "INSERT INTO nodesetup (name,intvalue) VALUES ('estat',$err)";
 else $sql = "UPDATE nodesetup SET intvalue = $err WHERE name = 'estat'";
 query($sql);
 $sql = "SELECT name FROM nodesetup WHERE name = 'estatc'";
 $rs = query($sql);
 if ($rs["num"] == 0) $sql = "INSERT INTO nodesetup (name,intvalue) VALUES ('estatc',$errc)";
 else $sql = "UPDATE nodesetup SET intvalue = $errc WHERE name = 'estatc'";
 query($sql);
}


?>
