<?php

class NodeCollectionDataSource extends ItemListActionDataSource
{
 var $d_coll;
 var $d_properties;
 var $d_idproperty;
 
 function NodeCollectionDataSource( &$coll, $headers )
 {
 $this->d_coll =& $coll;
 foreach ( $headers as $col=>$header )
 {
 $this->_addColumn( $col, $header );
 }
 }

 function setProperties( $props )
 {
 $this->d_properties = $props;
 }

 function setIdProperty( $idproperty ) {
 $this->d_idproperty = $idproperty;
 }

 function getPlainResultSet( $fromIdx, $toIdx, &$count, $search = "" ) {

 $ret = array();
 $it = $this->d_coll->iterator();
 while ( $it->hasNext() )
 {
 $next = &$it->next();
 $row = Array();
 foreach ( $this->d_properties as $prop )
 {
 $o_result = resolveProperty( $prop, $next );
 $row[$prop] = $o_result->toString();
 }
 if ($this->d_idproperty) {
 $o_result = resolveProperty( $this->d_idproperty, $next );
 $row["id"] = $o_result->toString();
 }
 $ret[] = $row;
 }
 
 return $ret;
 }
 
 function hasColumnHeaders()
 {
 return TRUE;
 }
 
}

?>
